//PIC24FJ64GA002 8MHz internal clock (PLL=32MHz)
//HtSC1602ɂUART eXgvO
//2007.9.20  
//
//PICUARTgp
//
//FMPLAB IDE v7.62
//RpCFC30 v3.01 (19 June 2007)
//C^[FPICkit2 v2.40
//
//RpCœK:
//MPLAB C30t PIC24FCugp:libpPIC24Fxxx-coff.a
//
//Fjo[T
//            HtSC1602
//PORTB 15 -  DB7
//PORTB 14 -  DB6
//PORTB 13 -  DB5
//PORTB 12 -  DB4
//PORTB 11 -  E
//PORTB 10 -  RS
//            R/WGND
//
//PORTB 6  - LED
//
//RP9(18pin) - UART TX
//RP8(17pin) - UART RX
//

#define USE_AND_OR     //CuORgp(CũCN[ht@COɒu)

#include "p24FJ64GA002.h"
#include "stdio.h"
#include "uart.h"
#include "lcd.h"

#define F_CPU           32000000UL  //CNbNg 32MHz

extern int delay_cycle(unsigned int n);
extern int delay_msec(unsigned int n, unsigned int m);
void __attribute__((__interrupt__)) _U1TXInterrupt(void);

/* Received data is stored in array Buf */
volatile char Buf[128];//i[̂́ApӂoCg1oCgȂ(wcntBufrcntBufƂ̓f[^Ӗ邽)
volatile int wcntBuf=0;//CgJEg
volatile int rcntBuf=0;//[hJEg

//CONFIG͂ohbetm̂̂Qlɂ܂(FNOSC_FRCPLLLɂĂ܂)
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & ICS_PGx1 & FWDTEN_OFF )
_CONFIG2(IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE)

void delay_ms(unsigned int ms)
{
    #define one_loop_cycle 1UL //one loop = 1 cycle
    #define clock_per_cycle 2UL // clock / cycle  (PTCNQNbNĂHH)
    #define delay_1msec_wk ((F_CPU/1000UL) / (one_loop_cycle*clock_per_cycle))
    #define delay_1msec_val (delay_1msec_wk-5UL) //-5UL͎ԕ␳l

    delay_msec(delay_1msec_val, ms);
}

/* This is UART1 receive ISR */
void __attribute__((__interrupt__)) _U1RXInterrupt(void)
{
    int len;
    IFS0bits.U1RXIF = 0;

    len = wcntBuf - rcntBuf;
    if(len<0) len = len + sizeof(Buf);

    if(len<sizeof(Buf)-1){
        Buf[wcntBuf] = ReadUART1();
        if(wcntBuf<sizeof(Buf)-1) wcntBuf++;
        else wcntBuf=0;
    }
    else ReadUART1();//ǂݎ̂
}

//UART1
void Uart1Init(void)
{
    unsigned int baudvalue;
    unsigned int U1MODEvalue;
    unsigned int U1STAvalue;

    wcntBuf=0;
    rcntBuf=0;

    CloseUART1();
    ConfigIntUART1(UART_RX_INT_EN | UART_RX_INT_PR4);//Enable RX荞, RXvCIeB[4

    #define BAUD_RATE 38400
    baudvalue = F_CPU/16/BAUD_RATE-1;//bps

    U1MODEvalue = UART_EN;//Enable Uart, Data 8bit, No Parity,
                          //1 stop bit, FlowȂ,LOOP BACKȂ,WAKEUPȂ,ABAUDȂ
                          //RX IDLE=1, ᑬ{[[g

    U1STAvalue = UART_TX_ENABLE;//Enable TX, 1charɎM荞, 

    OpenUART1(U1MODEvalue, U1STAvalue, baudvalue);
}

//Oobt@֏񂾃f[^M̂҂
void PutBufEndWait()
{
    while(BusyUART1());//M҂
}

//Oobt@֏(P)
void PutCharBuf(char dat)
{
    while(U1STAbits.UTXBF);//FIFO󂫑҂
    WriteUART1(dat);
}

//Oobt@֏()
void PutStrBuf(char *dat, int szbyte)
{
    while(szbyte--){
        while(U1STAbits.UTXBF);//FIFO󂫑҂
        WriteUART1(*dat++);
    }
}

//Oobt@ǂݍ
int GetCharBuf()
{
    int c;

    c = Buf[rcntBuf];

    if(rcntBuf!=wcntBuf){
        if(rcntBuf<sizeof(Buf)-1) rcntBuf++;
        else rcntBuf=0;
    }
    else{
        c = -1;//ǂݍ݂̃f[^͖
    }

    return (c);
}

//Oobt@̖ǂݍ݂̃oCg𓾂
int GetBufCnt()
{
    int len;
    len = wcntBuf - rcntBuf;

    if(len<0) len = len + sizeof(Buf);

    return(len);
}

int main()
{
    char str[17],c;
    int len;

    _RCDIV = 0;//PostScaler   ( 0 : 32MHz   1 : 16MHz )

    TRISB = 0b1111111110111111;//PORTB bit6 OUTPUT for LED
    RPINR18bits.U1RXR = 8;// UART1 RX input = RP8
    RPOR4bits.RP9R = 3;//UART TX output = RP9

    //t
    lcd_init();//|[g̏̒łȂĂ܂
    lcd_cls();//tʃNA

    Uart1Init();//UART1

    while(1){

        LATB &= ~0b0000000001000000;//LED _
        #define STRING "ABCDEabcde01234"
        PutStrBuf(STRING,sizeof(STRING)-1);//Oobt@֏
        PutBufEndWait();//Oobt@֏񂾃f[^M̂҂

        len = GetBufCnt();//Oobt@̖ǂݍ݂̃oCg𓾂
        sprintf(str,"cnt=%d", len);
        lcd_putstr(str);
        lcd_gotopos(0,1);

        while(1){
            c = GetCharBuf();//Oobt@ǂݍ
            if(c==-1) break;
            lcd_putch((char)(c & 0xff));//Mf[^\
        }

        rcntBuf = wcntBuf;

        LATB |= 0b0000000001000000;//LED 
        delay_ms(1000);
        lcd_cls();
    }

    /* Turn off UART1 module */
    CloseUART1();

    return 1;
}


